package com.planet_ink.coffee_mud.core.intermud.i3.packets;
import com.planet_ink.coffee_mud.core.intermud.i3.server.*;
import com.planet_ink.coffee_mud.core.interfaces.*;
import com.planet_ink.coffee_mud.core.*;
import com.planet_ink.coffee_mud.core.collections.*;
import com.planet_ink.coffee_mud.Abilities.interfaces.*;
import com.planet_ink.coffee_mud.Areas.interfaces.*;
import com.planet_ink.coffee_mud.Behaviors.interfaces.*;
import com.planet_ink.coffee_mud.CharClasses.interfaces.*;
import com.planet_ink.coffee_mud.Commands.interfaces.*;
import com.planet_ink.coffee_mud.Common.interfaces.*;
import com.planet_ink.coffee_mud.Exits.interfaces.*;
import com.planet_ink.coffee_mud.Items.interfaces.*;
import com.planet_ink.coffee_mud.Locales.interfaces.*;
import com.planet_ink.coffee_mud.MOBS.interfaces.*;
import com.planet_ink.coffee_mud.Races.interfaces.*;


import java.util.Vector;

/**
 * Copyright (c) 1996 George Reese
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *  	  http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 */
@SuppressWarnings("rawtypes")
public class ChannelAdd extends Packet  {
	public String channel = null;

	public ChannelAdd()
	{
		super();
		type = Packet.CHAN_ADD;
	}
	public ChannelAdd(Vector v) throws InvalidPacketException {
		super(v);
		try {
			type = Packet.CHAN_ADD;
			channel = (String)v.elementAt(6);
		}
		catch( ClassCastException e ) {
			throw new InvalidPacketException();
		}
	}

	
	public ChannelAdd(int t, String chan, String who) {
		super();
		type = t;
		channel = chan;
		sender_name = who;
	}

	public void send() throws InvalidPacketException {
		if( channel == null  ) {
			throw new InvalidPacketException();
		}
		super.send();
	}

	public String toString() {
		NameServer n = Intermud.getNameServer();
		String str=
			 "({\"channel-add\",5,\"" + I3Server.getMudName() + "\",\"" +
			   sender_name + "\",\""+n.name+"\",0,\"" + channel + "\",0,})";
		return str;
	}
}
