package com.planet_ink.miniweb.interfaces;

import com.planet_ink.miniweb.http.HTTPMethod;

/*
Copyright 2012-2013 Bo Zimmerman

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

	   http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

/**
 * This is the basic interface that "simple servlets" are provided, 
 * providing access to the request data and an interface to control
 * the server response.
 */
public interface SimpleServlet 
{
	public void init();
	public void doGet(SimpleServletRequest request, SimpleServletResponse response);
	public void doPost(SimpleServletRequest request, SimpleServletResponse response);
	public void service(HTTPMethod method, SimpleServletRequest request, SimpleServletResponse response);
}
 
